# Method: projects.snapshots.list

- [HTTP request](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.snapshots/list#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.snapshots/list#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.snapshots/list#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.snapshots/list#body.request_body)
- [Response body](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.snapshots/list#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.snapshots/list#body.ListSnapshotsResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.snapshots/list#body.aspect)
- [Try it!](https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.snapshots/list#try-it)

Lists the existing snapshots. Snapshots are used in \[subscriptions.seek\]( <https://cloud.google.com/pubsub/docs/replay-overview>) operations, which allow you to manage message acknowledgments in bulk. That is, you can set the acknowledgment state of messages in an existing subscription to the state captured by a snapshot.

### HTTP request

Choose a location:
<button value="global" default="">global</button>   
`GET https://pubsub.googleapis.com/v1/{project}/snapshots`

<br />

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` Required. The name of the project in which to list snapshots. Format is `projects/{project-id}`. |

### Query parameters

| Parameters ||
|---|---|
| `pageSize` | `integer` Optional. Maximum number of snapshots to return. |
| `pageToken` | `string` Optional. The value returned by the last `ListSnapshotsResponse`; indicates that this is a continuation of a prior `snapshots.list` call, and that the system should return the next page of data. |

### Request body

The request body must be empty.

### Response body

Response for the `snapshots.list` method.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "snapshots": [ { object (`https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.snapshots#Snapshot`) } ], "nextPageToken": string } ``` |

| Fields ||
|---|---|
| `snapshots[]` | ``object (`https://docs.cloud.google.com/pubsub/docs/reference/rest/v1/projects.snapshots#Snapshot`)`` Optional. The resulting snapshots. |
| `nextPageToken` | `string` Optional. If not empty, indicates that there may be more snapshot that match the request; this value should be passed in a new `ListSnapshotsRequest`. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/pubsub`
- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).